class Editor.PanelEditor.Dialog extends Editor.Dialog
  className: 'panel-editor-dialog'
  
  initialize: (options) ->
    super(options)
    @target_model = options.target_model
    @history = new Pettanr.Views.History({parent: this})
    @listenTo(@history, 'http_get', @http_get)
    @listenTo(@history, 'get', @get)
  
  start: (@target_model, params, form) ->
    super(params, form)
  
  refresh: (view) ->
    this.$el.html('')
    this.$el.append(@history.render().el)
    @append_rb()
    this.$el.append(view.el)
  
  getter_proxy: () ->
    proxy = super()
    @listenTo(proxy, 'title', @push_history)
    proxy
  
  ready: (view) ->
    @listenTo(view, 'http_get', @http_get)
    # @listenTo(view, 'http_post', @http_post)
    @listenTo(view, 'pick', @pick)
    if view['is_pickable'] and view.is_pickable()
      view.add_pick(@target_model)
    @refresh(view)
    this.$el.dialog('open')
  
  push_history: (params, str = null) ->
    @history.push(params, str)
  
  pick: (item) ->
    @trigger('pick', item)
  
