class Locmare.ProfilerModule.ColumnModule.Base extends Pettanr.View
  tagName: 'div'
  className: 'column'
  
  initialize: (options) ->
    @profiler = options.profiler
    @column_manifest = options.column_manifest
    @column_name = @column_manifest.name
    c = @label_class()
    @label = new c({column: this})
    c = @value_class()
    @value = new c({column: this})
    c = @note_class()
    @note = new c({column: this})
  
  render: () ->
    this.$el.html('')
    this.$el.append(@label.render().el)
    this.$el.append(@value.render().el)
    this.$el.append(@note.render().el) if @note.is_visible()
    this
  
  item: () ->
    @profiler.item
  
  label_class: () ->
    Locmare.ProfilerModule.ColumnModule.Label
  
  value_class: () ->
    Locmare.ProfilerModule.ColumnModule.Value
  
  note_class: () ->
    Locmare.ProfilerModule.ColumnModule.NoteNone
  
class Locmare.ProfilerModule.ColumnModule.Label extends Pettanr.View
  tagName: 'span'
  
  initialize: (options) ->
    @column = options.column
  
  render: () ->
    this.$el.html(@label())
    this
  
  label: () ->
    Pettanr.AppHelper.t_a(@column.item().item_name(), @column.column_name)
  
class Locmare.ProfilerModule.ColumnModule.Value extends Pettanr.View
  tagName: 'span'
  
  initialize: (options) ->
    @column = options.column
  
  render: () ->
    this.$el.html(@value())
    this
  
  value: () ->
    @column.item().escape(@column.column_name)
  
class Locmare.ProfilerModule.ColumnModule.DateValue extends Pettanr.View
  tagName: 'span'
  
  initialize: (options) ->
    @column = options.column
  
  render: () ->
    this.$el.html(@value())
    this
  
  value: () ->
    @column.item().get(@column.column_name)
    #Pettanr.format_date(@column.item().get(@column.column_name))
  
class Locmare.ProfilerModule.ColumnModule.JsonValue extends Pettanr.View
  tagName: 'pre'
  
  initialize: (options) ->
    @column = options.column
  
  render: () ->
    this.$el.html(@value())
    this
  
  value: () ->
    # pre tag no need escapeHTML
    JSON.stringify(JSON.parse(@column.item().get(@column.column_name)), null, 2)
  
class Locmare.ProfilerModule.ColumnModule.ExtendValue extends Pettanr.View
  tagName: 'div'
  
  initialize: (options) ->
    @column = options.column
    @columns = {}
    _.each @extend_settings().column_names, (extend_column_name) =>
      extend_column_manifest = @extend_settings().columns[extend_column_name] || {}
      @columns[extend_column_name] = new Locmare.ProfilerModule.ColumnModule.ExtendModule.ExtendColumn({
        column: this, 
        extend_column_name: extend_column_name, 
        extend_column_manifest: extend_column_manifest
      })
  
  render: () ->
    this.$el.html('')
    _.each @sorted_columns(), (extend_column) =>
      this.$el.append(extend_column.render().el)
    this
  
  sorted_columns: () ->
    _.map @extend_settings().column_names, (column_name) =>
      @columns[column_name]
  
  extend_settings: () ->
    @template_model_profiler().extend_settings[@booster().item_name()]
  
  template_model_profiler: () ->
    LocalManifest.manifest().profilers[@template_model().item_name()]
  
  template_model: () ->
    @booster().template_model()
  
  extend_item: () ->
    @booster().extend_item()
  
  booster: () ->
    @column.item().boosters[@column.column_manifest.boost_name]
  
class Locmare.ProfilerModule.ColumnModule.NoteNone
  
  is_visible:() ->
    false
  
class Locmare.ProfilerModule.ColumnModule.Note extends Pettanr.View
  tagName: 'span'
  
  initialize: (options) ->
    @column = options.column
  
  render: () ->
    this.$el.html(@note())
    this
  
  note: () ->
    Pettanr.AppHelper.t_selected_item(@select_item_name(), @column.value.value())
  
  is_visible:() ->
    true
  
  select_item_name: () ->
    @model_attribute_source_manifest().select_item_name
  
  model_manifest: () ->
    Manifest.manifest().models[@column.profiler.item_name]
  
  model_attribute_manifest: () ->
    @model_manifest().attributes[@column.column_name]
  
  model_attribute_source_manifest: () ->
    @model_attribute_manifest().source
