class ManifestBase
  
  @require_modules: (path, names) ->
    _.each names, (name) ->
      require_dependency path + name.to_s
  
  @module_message: (module_names, my_module_names = []) ->
    module_names.concat(my_module_names).join(' > ')
  
  @alert_message: (message, location) ->
    confirm('invalid manifest?:' + message + " for " + message)
  
  @alert_undefined_message: (name, location) ->
    alert_message('undefined ' + name, location)
  
  @load_value: (_self, json, module_name, klass) ->
    new klass(_self, json[module_name], module_name)
  
  @load_name_values: (_self, jsons, module_name, klass) ->
    hash = {}
    _.each jsons[module_name], (_json, _name) ->
      hash[_name] = new klass(_self, _name, _json, module_name)
    hash
  
  @load_type_args: (_self, jsons, module_name, klass) ->
    klass.factory_type_args(_self, jsons[module_name], module_name, klass)
  
  @load_type_name_args: (_self, jsons, module_name, klass) ->
    hash = {}
    ha = jsons[module_name]
    _.each jsons[module_name], (_json, _name) ->
      hash[_name] = new klass.factory(_self, _name, _json, module_name, klass)
    hash
  
  @load_names: (_self, json, module_name, klass) ->
    _.map json[module_name], (_name) ->
      new klass(_self, _name, module_name)

@ManifestBase = ManifestBase
