class Pettanr.ResourcePicture extends Peta.Content
  
  @singular: () ->
    'ResourcePicture'
  
  @plural: () ->
    'ResourcePictures'
  
  defaults: {
    id: null
  } 
  
  @trace_routes: () ->
    {
      picture: ['resource_picture_picture', 'picture']
    }
  
  is_visible: (operators = Pettanr.cache.operators) ->
    @is_user_visible(operators)
  
  filename: () ->
    @get('id') + '.' + @get('ext')
  
  gifname: () ->
    @get('id') + '.gif'
  
  mime_type: () ->
    'image/' + @get('ext')
  
  r_url: (subdir = null) ->
    opt = if _.isEmpty(subdir)
      ''
    else
      '?subdir=' + Pettanr.to_s(subdir)
    '/resource_pictures/' + @filename() + opt
  
  symbol_file: () ->
    subdir = if @no_resize()
      'full'
    else
      null
    super(subdir)
  
  no_resize: () ->
    false
  
  alt_name: () ->
    lgn = Pettanr.to_s(@license().license_group().get('caption'))
    ln = Pettanr.to_s(@license().get('caption'))
    lgn + '[' + ln + ']'
  
  symbol_option: (context, options) ->
    @retrieve(this, {
      success: (symbol_item) => 
        options.success.call(context, symbol_item.symbol_file())
    })
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
  
