class BalloonsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => [:new, :edit, :create, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :edit, :create, :update, :destroy]
  else
    before_action :authenticate_reader, :only => [
      :index, :show, 
      :by_author, :by_speech_balloon, :by_speech_balloon_template, :by_system_picture
    ]
    before_action :authenticate_user, :only => [:new, :edit, :create, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :edit, :create, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_author
    filer_list param: params[:id]
  end
  
  def by_speech_balloon
    filer_list param: params[:id]
  end
  
  def by_speech_balloon_template
    filer_list param: params[:id]
  end
  
  def by_system_picture
    filer_list param: params[:id]
  end
  
  def show_html_format format
    format.html {
      @item.boosts 'post'
      @balloon = @item
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
end
