module Editor
  module EditorModule
    module DockModule
      class ScenarioBoard < Board
        attr_accessor :element
        
        def initialize parent, index, name, element
          super parent, index, name
          @element = element
        end
        
      end
      
      module TabModule
        class ScenarioBoardLabel < BoardLabel
          def template_file_name
            'board_label'
          end
          
          def face_template_name
            self.element.path_name + '/element_face'
          end
          
        end
        
        class ScenarioBoardBody < BoardBody
          attr_accessor :bucket
          
          def initialize parent
            super
            @bucket = ScenarioBucket.new self, self.board.element
          end
          
          def template_name
            @bucket.template_name
          end
          
          def template_options
            @bucket.template_options
          end
          
        end
        
      end
    end
  end
end
