ManifestBase.require_modules "local_manifest/profiler/association/", 
  %w|belongs_to has_many has_one|

module LocalManifest
  module ProfilerModule
    class Association < ManifestBase::Values
      include AssociationModule
      attr :belongs_to, :has_many, :has_one
      
      def set_default
        super
        @values['belongs_to'] ||= []
        @values['has_many'] ||= []
        @values['has_one'] ||= []
      end
      
      def init
        super
        @belongs_to = ManifestBase.load_names self, @values, 'belongs_to', BelongsTo
        @has_many = ManifestBase.load_names self, @values, 'has_many', HasMany
        @has_one = ManifestBase.load_names self, @values, 'has_one', HasOne
      end
      
      def profiler
        @parent
      end
      
      def profiler_name
        @parent.name
      end
      
    end
    
  end
end
